\ Invert2.f produces v2.txt = validation.htm
\ After Waclena

\ Fools
1 CELLS CONSTANT CELL

: place  ( ca1 u ca2 -- )
   2DUP 2>R CHAR+ SWAP CHARS MOVE 2R> C! ;

: string,  ( ca1 u ca2 -- )
   HERE OVER 1+ CHARS ALLOT PLACE ;

: scan  ( ca1 u1 char -- ca2 u2 )
   >R BEGIN DUP WHILE OVER C@ R@ <> WHILE 1 /STRING REPEAT THEN
   R> DROP ;

\ Binary tree words
CREATE URLs 0 ,

4 CELLS CONSTANT twig \ *string, left, right, filenames
: left  ( a1 -- a2 )  CELL+ ;
: right  ( a1 -- a2 )  2 CELLS + ;
: filenames  ( a1 -- a2 )  3 CELLS + ;

: new-twig  ( node a u -- anode )
   2>R ALIGN HERE TUCK
       twig + , 0 , 0 , 0 , !  HERE CELL -
   2R> string, ;

\ Linked-list word
: new-node  ( struct a u -- )
   2>R DUP
   BEGIN NIP DUP @ DUP WHILE
      DUP CELL+ COUNT 2R@ COMPARE 0> UNTIL THEN
   ALIGN HERE SWAP ,  SWAP !  2R> string, ;

\ New twig if new URL
: ?twig  ( node a u -- )
   2>R DUP @
   0= IF 2R@ new-twig ROT ROT new-node  ELSE
   @ DUP @ COUNT 2R@ COMPARE
      ?DUP 0= IF filenames ROT ROT new-node  ELSE
           0< IF right ELSE left THEN 2R@ RECURSE
   THEN THEN 2R> 2DROP ;

0 VALUE fid
9 CONSTANT Tabchar
CREATE tabpad  Tabchar C,  ALIGN

\ Split a line a the tab character
: a|b  ( a u -- a1 u1 a2 u2 )
   2DUP Tabchar SCAN TUCK 2>R - 2R> 1 /STRING ;

\ File input words
: open-in  ( -- )
   S" input.html" R/O OPEN-FILE THROW TO fid ;
: close-in  ( -- ) 
   fid CLOSE-FILE THROW ;

255 CONSTANT maxin  \ Increase to suit
CREATE lpad maxin CHARS ALLOT
: read-in  ( -- )
   BEGIN lpad DUP maxin fid READ-LINE THROW
   WHILE  a|b URLs ROT ROT ?twig REPEAT 2DROP ;

\ File output words
\ Line format: URL<tab>filename...<tab>filename
\ Write a filename preceded by a tabchar
: write-filename  ( node -- )
    tabpad 1 fid WRITE-FILE THROW
    COUNT fid WRITE-FILE THROW  ;
    
\ Write atwigs
: write-filenames  ( filenames -- )
   BEGIN @ DUP WHILE DUP CELL+ write-filename REPEAT DROP ;

\ Write a URL and the files it is in
: write-URL  ( url -- )
   DUP @ COUNT fid WRITE-FILE THROW
   filenames write-filenames  
   PAD 0 fid WRITE-LINE THROW ;

\ Write URLs
: write-URLs  ( urls -- )
   @ ?DUP
   IF DUP left RECURSE
      DUP write-URL
          right RECURSE
   THEN ;

: write-out ( -- )
   S" v2.txt" R/W CREATE-FILE THROW TO fid
   URLs write-URLs
   fid CLOSE-FILE THROW ;

\ COUNTER and TIMER are SwiftForth timing words
open-in read-in close-in write-out
